SimpleDialog subclass: #PasswordDialog
	instanceVariableNames: 'password callback sender text '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!PasswordDialog methodsFor: 'aspects'!

password
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^password isNil
		ifTrue:
			[password := String new asValue]
		ifFalse:
			[password]!

text
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^text isNil
		ifTrue:
			[text := String new asValue]
		ifFalse:
			[text]! !

!PasswordDialog methodsFor: 'accessing'!

callback: aSymbol 
	callback := aSymbol!

sender: anObject 
	sender := anObject! !

!PasswordDialog methodsFor: 'closing'!

acceptAndClose
	"Return password to sender and close window."
	sender perform: callback with: text value.
	self closeRequest!

cancelAndClose
	"Return empty string to sender and close window."

	sender perform: callback with: ''.
	self closeRequest! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PasswordDialog class
	instanceVariableNames: ''!


!PasswordDialog class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Password Dialog' 
			#bounds: #(#Rectangle 300 256 500 345 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#LabelSpec 
					#layout: #(#Point 39 8 ) 
					#label: 'Enter your password' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 48 29 148 54 ) 
					#model: #text 
					#type: #password ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 5 61 83 84 ) 
					#model: #acceptAndClose 
					#label: 'Accept' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 116 61 194 84 ) 
					#model: #cancelAndClose 
					#label: 'Cancel' 
					#defaultable: true ) ) ) )! !

!PasswordDialog class methodsFor: 'creation'!

openFrom: anObject onClosing: aSymbol 
	"Open password window and return result to anObject."

	^(self new sender: anObject; callback: aSymbol) open! !

ApplicationModel subclass: #WindowWithMenuBar
	instanceVariableNames: 'text '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!WindowWithMenuBar methodsFor: 'aspects'!

text
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^text isNil
		ifTrue:
			[text := String new asValue]
		ifFalse:
			[text]! !

!WindowWithMenuBar methodsFor: 'initialization'!

postBuildWith: aBuilder 
	self enableHideText! !

!WindowWithMenuBar methodsFor: 'menu'!

close
	self closeRequest!

enableHideText
	"Enable 'Hide text' command and disable 'Show text' command."

	"Get menu bar menu."
	| menu submenu |
	menu := self builder menuAt: #menuBar.	
	"Get the appropriate submenu."
	submenu := menu valueForMenuItem: (menu menuItemLabeled: 'Configure').	
	"Modify the appropriate menu items."
	(submenu menuItemLabeled: 'Show text') disable.
	(submenu menuItemLabeled: 'Hide text') enable!

enableShowText
	"Enable 'Hide text' command and disable 'Show text' command."

	"Get menu bar menu."
	| menu submenu |
	menu := self builder menuAt: #menuBar.	
	"Get the appropriate submenu."
	submenu := menu valueForMenuItem: (menu menuItemLabeled: 'Configure').	
	"Modify the appropriate menu items."
	(submenu menuItemLabeled: 'Show text') enable.
	(submenu menuItemLabeled: 'Hide text') disable!

hideText
	(self builder componentAt: #text) beInvisible.
	self enableShowText!

menuBar
	"Create instance of Menu for the menu bar."

	"Create instance of Menu for the menu bar."
	| menuBuilder |
	"Create a MenuBuilder."
	menuBuilder := MenuBuilder new.
	"Use it to construct submenus."
	menuBuilder beginSubMenuLabeled: 'File';		"This label appears in the menu bar."
		add: 'Print' -> #print;			"Drop-down menu starts here."
		add: 'Close' -> #closeRequest;
		endSubMenu.				"Drop-down menu ends here."
	menuBuilder beginSubMenuLabeled: 'Configure'; 	"This label appears in the menu bar."
		add: 'Show text' -> #showText; 		"Drop-down menu starts here."
		add: 'Hide text' -> #hideText;
		endSubMenu.				"Drop-down menu ends here."
	"Ask MenuBuilder to construct and return the menu."
	^menuBuilder menu!

print
	Transcript cr; show: text value!

showText
	(self builder componentAt: #text) beVisible.
	self enableShowText! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WindowWithMenuBar class
	instanceVariableNames: ''!


!WindowWithMenuBar class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Window With Menu Bar' 
			#bounds: #(#Rectangle 300 200 662 380 ) 
			#flags: 4 
			#menu: #menuBar 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#TextEditorSpec 
					#layout: #(#Rectangle 4 5 358 156 ) 
					#name: #text 
					#model: #text ) ) ) )! !

ApplicationModel subclass: #ListWithPopup2
	instanceVariableNames: 'list listHolderMenu '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!ListWithPopup2 methodsFor: 'initialization'!

initialize
	"Assign initial popup menu to the list and register interest in selection changes."

	listHolderMenu := self menuWithoutDelete asValue.
	list := SelectionInList new.
	list selectionIndexHolder onChangeSend: #changedMenu to: self! !

!ListWithPopup2 methodsFor: 'aspects'!

list
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^list isNil
		ifTrue:
			[list := SelectionInList new]
		ifFalse:
			[list]! !

!ListWithPopup2 methodsFor: 'changes'!

changedMenu
	"Context may have changed - assign the appropriate popup menu."

	self listHolderMenu value: (list selection isNil
			ifTrue: [self menuWithoutDelete]
			ifFalse: [self menuWithDelete])! !

!ListWithPopup2 methodsFor: 'menu commands'!

addItem
	list list: (list list add: (Dialog request: 'Enter new label' initialAnswer: ''); yourself)!

deleteItem
	| selection |
	selection := list selection.
	selection isNil ifTrue: [^self].
	list list: ((list list) remove: selection; yourself)!

menuWithDelete
	"Calculate menu with add and delete commands."

	| menuBuilder |
	menuBuilder := MenuBuilder new.	"Label-value pair."
	menuBuilder add: 'add' -> #addItem; add: 'delete' -> #deleteItem.
	^menuBuilder menu!

menuWithoutDelete
	"Calculate menu with add and delete commands."

	| menuBuilder |
	menuBuilder := MenuBuilder new.	"Label-value pair."
	menuBuilder add: 'add' -> #addItem.
	^menuBuilder menu! !

!ListWithPopup2 methodsFor: 'accessing'!

listHolderMenu
	^listHolderMenu! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ListWithPopup2 class
	instanceVariableNames: ''!


!ListWithPopup2 class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'List With Pop Up - Style 2' 
			#bounds: #(#Rectangle 270 230 531 371 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 9 9 255 130 ) 
					#model: #list 
					#menu: #listHolderMenu 
					#useModifierKeys: true 
					#selectionType: #highlight ) ) ) )! !

ApplicationModel subclass: #SimpleNotebook
	instanceVariableNames: 'pages '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!SimpleNotebook methodsFor: 'aspects'!

pages
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^pages isNil
		ifTrue:
			[pages := SelectionInList new]
		ifFalse:
			[pages]! !

!SimpleNotebook methodsFor: 'initialization'!

initialize
	"Define tabs and their labels, register interest in tab changes."

	pages := SelectionInList with: #('page1' 'page2').
	pages selectionIndexHolder onChangeSend: #newPage to: self!

postOpenWith: aBuilder 
	"Specify initial tab selection."

	pages selectionIndex: 1! !

!SimpleNotebook methodsFor: 'changes'!

newPage
	"Tab selection has changed, display the appropriate page."

	"Get notebook widget from the builder."
	| widget |
	widget := (self builder componentAt: #notebook) widget.
	pages selectionIndex = 1
		ifTrue: ["Display appropriate canvas."
			widget client: self spec: #page1]
		ifFalse: [widget client: self spec: #page2]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SimpleNotebook class
	instanceVariableNames: ''!


!SimpleNotebook class methodsFor: 'interface specs'!

page1
	"UIPainter new openOnClass: self andSelector: #page1"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#Rectangle 397 184 576 428 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#RegionSpec 
					#layout: #(#Rectangle 22 26 101 123 ) 
					#colors: 
					#(#LookPreferences 
						#setForegroundColor: #(#ColorValue #springGreen ) 
						#setBackgroundColor: #(#ColorValue 7044 7044 7044 ) ) 
					#lineWidth: 1 ) 
				#(#RegionSpec 
					#layout: #(#Rectangle 58 64 138 203 ) 
					#colors: 
					#(#LookPreferences 
						#setForegroundColor: #(#ColorValue 8191 4607 1024 ) ) 
					#lineWidth: 4 
					#regionType: #ellipse ) ) ) )!

page2
	"UIPainter new openOnClass: self andSelector: #page2"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#Rectangle 397 184 576 428 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#RegionSpec 
					#layout: #(#Rectangle 22 26 164 158 ) 
					#colors: 
					#(#LookPreferences 
						#setForegroundColor: #(#ColorValue 8191 6143 8191 ) 
						#setBackgroundColor: #(#ColorValue 2048 8191 8191 ) ) 
					#lineWidth: 4 ) 
				#(#RegionSpec 
					#layout: #(#Rectangle 26 64 154 221 ) 
					#colors: 
					#(#LookPreferences 
						#setForegroundColor: #(#ColorValue 4096 0 8191 ) 
						#setBackgroundColor: #(#ColorValue 7167 8191 8191 ) ) 
					#lineWidth: 4 
					#regionType: #ellipse ) ) ) )!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Simple Notebook' 
			#bounds: #(#Rectangle 365 172 648 460 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#NoteBookSpec 
					#layout: #(#Rectangle 11 10 290 301 ) 
					#name: #notebook 
					#model: #pages ) ) ) )! !

ApplicationModel subclass: #ListWithPopup1
	instanceVariableNames: 'list '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!ListWithPopup1 methodsFor: 'aspects'!

list
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^list isNil
		ifTrue:
			[list := SelectionInList new]
		ifFalse:
			[list]! !

!ListWithPopup1 methodsFor: 'menu commands'!

addItem
list list: (list list add: (Dialog request: 'Enter new label' initialAnswer: ''); yourself)!

deleteItem
	| selection |
	selection := list selection.
	selection isNil ifTrue: [^self].
	list list: ((list list) remove: selection; yourself)! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ListWithPopup1 class
	instanceVariableNames: ''!


!ListWithPopup1 class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'List With Pop Up - Style 1' 
			#bounds: #(#Rectangle 300 200 561 341 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 9 9 255 130 ) 
					#model: #list 
					#menu: #listHolderMenu 
					#useModifierKeys: true 
					#selectionType: #highlight ) ) ) )! !

!ListWithPopup1 class methodsFor: 'resources'!

listHolderMenu
	"MenuEditor new openOnClass: self andSelector: #listHolderMenu"

	<resource: #menu>
	^#(#Menu #(
			#(#MenuItem 
				#rawLabel: 'add' 
				#value: #addItem ) 
			#(#MenuItem 
				#rawLabel: 'delete' 
				#value: #deleteItem ) ) #(2 ) nil ) decodeAsLiteralArray! !

ApplicationModel subclass: #FileDisplay
	instanceVariableNames: 'list1 list2 filename directoryString contents alphabet divider files '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!FileDisplay methodsFor: 'aspects'!

alphabet
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^alphabet isNil
		ifTrue:
			[alphabet := SelectionInList new]
		ifFalse:
			[alphabet]!

contents
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^contents isNil
		ifTrue:
			[contents := String new asValue]
		ifFalse:
			[contents]!

divider
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^divider isNil
		ifTrue:
			[divider := SelectionInList new]
		ifFalse:
			[divider]!

files
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^files isNil
		ifTrue:
			[files := String new asValue]
		ifFalse:
			[files]!

subcanvas! !

!FileDisplay methodsFor: 'changes'!

changedHalf
	"Minor tab selection has changed. Display the appropriate list of minor tabs and propagate changes."

	| letter |
	divider selection = 'm-z'
		ifTrue: 
			[alphabet list: list2.
			letter := $m]
		ifFalse: 
			[alphabet list: list1.
			letter := $a].
	files list: (filename directoryContents select: [:fileName | (fileName at: 1) asUppercase = letter])!

changedLetter
	"Display new list of files."

	| path |
	alphabet selectionIndex = 0 ifTrue: [alphabet selectionIndex: 1].
	path := directoryString copyWith: Filename separator.
	files list: (path asFilename directoryContents select: [:string | (path , string) asFilename isDirectory not & ((string at: 1) asUppercase = (alphabet selection at: 1) asUppercase)])!

newFileSelection
	"A new file has been selected. Display its contents or blank the text editor."

	| text |

	files selectionIndex = 0
		ifTrue: [text := '']
		ifFalse: [text := ((directoryString copyWith: Filename separator), files selection) asFilename contentsOfEntireFile].
	self contents value: text! !

!FileDisplay methodsFor: 'actions'!

newDirectory
	"Get directory name and switch to it if it is valid."

	| dirString dirName |
	dirString := Dialog request: 'Enter complete filename path as in C: or C:\visual' initialAnswer:  'C:'.
	dirString isEmpty | (dirName := dirString asFilename) isDirectory not
		ifTrue: [^Dialog warn: dirName asString , ' is not a valid directory.']
		ifFalse: [directoryString := dirString].
			self builder window label: ('Files in directory: ' , directoryString copyWith: Filename separator).
			divider selectionIndex: 1.
			alphabet selectionIndex: 1! !

!FileDisplay methodsFor: 'initialization'!

initialize
	| offset |
	"Calculate tab labels. They are one-letter strings containing consecutive letters of the alphabet."
	list1 := Array new: 14.
	list2 := Array new: 14.
	offset := $a asInteger - 1.
	1 to: list1 size do: [:index | list1 at: index put: (String with: (index + offset) asCharacter)].
	1 to: list2 size do: [:index | list2 at: index put: (String with: (index + offset + 12) asCharacter)].	
	"Define major and minor tabs. Minor tabs are fixed, major tabs depend on the selected minor tab."
	alphabet := SelectionInList with: list1.
	divider := SelectionInList with: #('a-n' 'm-z').	"Define change messages for notebook tabs."
	"The contents of the file list will initially be files in C:\ starting with letter a."
	directoryString := 'C:'.
	files := SelectionInList with: ((filename := Filename named: directoryString) directoryContents select: [:fName | 
					(fName at: 1) asUppercase = $A]) asSortedCollection.
	alphabet selectionIndex: 1.
	divider selectionIndex: 1.
	"No file is initially selected."
	files selectionIndex: 0.	
	"Change of filename list selection and major or minor tab tiggers a change message."
	files selectionIndexHolder onChangeSend: #newFileSelection to: self.
	alphabet selectionIndexHolder onChangeSend: #changedLetter to: self.
	divider selectionIndexHolder onChangeSend: #changedHalf to: self.!

postOpenWith: aBuilder 	
"Assign window label."
	self builder window label: 'Files in directory: c:\'.
	"Assign the file list subcanvas to the notebook page."
	(aBuilder componentAt: #pageHolder) widget client: self spec: #subCanvas! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

FileDisplay class
	instanceVariableNames: ''!


!FileDisplay class methodsFor: 'interface specs'!

subCanvas
	"UIPainter new openOnClass: self andSelector: #subCanvas"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Subcanvas' 
			#bounds: #(#Rectangle 307 123 493 477 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 11 10 178 349 ) 
					#model: #files 
					#useModifierKeys: true 
					#selectionType: #highlight ) ) ) )!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Unlabeled Canvas' 
			#min: #(#Point 593 426 ) 
			#max: #(#Point 593 426 ) 
			#bounds: #(#Rectangle 104 87 697 513 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#NoteBookSpec 
					#layout: #(#Rectangle 16 9 301 411 ) 
					#name: #pageHolder 
					#model: #alphabet 
					#secondModel: #divider ) 
				#(#TextEditorSpec 
					#layout: #(#Rectangle 308 9 578 387 ) 
					#model: #contents ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 308 396 422 421 ) 
					#model: #newDirectory 
					#label: 'New directory' 
					#defaultable: true ) ) ) )! !

Object subclass: #NameOfClass
	instanceVariableNames: 'password '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


ApplicationModel subclass: #SubcanvasTest
	instanceVariableNames: 'interface '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!SubcanvasTest methodsFor: 'changes'!

newInterface
	"Switch to the subcanvas corresponding to the active radio button."

	"Get subcanvas widget from the builder."
	| subcanvas |
	subcanvas := (self builder componentAt: #subcanvas) widget.	"Assign to it the canvas described in the appropriate spec method defined in this class."
	subcanvas client: self spec: interface value! !

!SubcanvasTest methodsFor: 'accessing'!

subcanvasAppModel
	^self! !

!SubcanvasTest methodsFor: 'initialization'!

initialize
	"Activate radio button #interface1, register interest in button setting."

	interface := #interface1 asValue.
	interface onChangeSend: #newInterface to: self!

postOpenWith: aBuilder 
	"Display the initial subcanvas."

	self newInterface! !

!SubcanvasTest methodsFor: 'aspects'!

interface
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^interface isNil
		ifTrue:
			[interface := nil asValue]
		ifFalse:
			[interface]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SubcanvasTest class
	instanceVariableNames: ''!


!SubcanvasTest class methodsFor: 'interface specs'!

interface1
	"UIPainter new openOnClass: self andSelector: #interface1"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#Rectangle 508 281 708 383 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#LabelSpec 
					#layout: #(#Point 61 10 ) 
					#label: 'Interface 1' ) ) ) )!

interface2
	"UIPainter new openOnClass: self andSelector: #interface2"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Unlabeled Canvas' 
			#bounds: #(#Rectangle 508 281 708 383 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#LabelSpec 
					#layout: #(#Point 61 10 ) 
					#label: 'Interface 2' ) ) ) )!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Subcanvas Test' 
			#min: #(#Point 200 135 ) 
			#max: #(#Point 200 135 ) 
			#bounds: #(#Rectangle 300 200 500 335 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#RadioButtonSpec 
					#layout: #(#Point 17 21 ) 
					#model: #interface 
					#label: 'Interface 1' 
					#select: #interface1 ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 18 53 ) 
					#model: #interface 
					#label: 'Interface 2' 
					#select: #interface2 ) 
				#(#SubCanvasSpec 
					#layout: #(#Rectangle 12 81 187 127 ) 
					#name: #subcanvas 
					#flags: 0 
					#clientKey: #subcanvasAppModel ) ) ) )! !

ApplicationModel subclass: #Diary
	instanceVariableNames: 'selectedDate newCalendar notes note '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!Diary methodsFor: 'accessing'!

newCalendar
	"Return and possibly calculate appropriate date by lazy initialization."

	^newCalendar isNil
		ifTrue: 
			[| date |
			date := Date today.
			^newCalendar := Calendar
				newOnMonth: date monthIndex
				year: date year
				from: self
				message: #selection:]
		ifFalse: [newCalendar]! !

!Diary methodsFor: 'menu'!

addNote
	notes at: selectedDate value put: note value.!

newMenu
	"Redefine accept."

	| mb |
	mb := MenuBuilder new.
	mb "First add predefined command combinations."
		addFindReplaceUndo; 
		line; 
		addCopyCutPaste; 
		line; 
		"Now add customized commands."
		add: 'accept' -> #addNote; 	"This is new."
		add: 'cancel' -> #cancel.	"	This is standard."
	^mb menu! !

!Diary methodsFor: 'actions'!

newDate
	"Request new date and open calendar on the corresponding month and year."
	"Obtain new month and year from the user."

	| month year sub |
	selectedDate value: (Date
			newDay: 1
			monthNumber: (month := (Dialog request: 'Enter number of month' initialAnswer: '') asNumber)
			year: (year := (Dialog request: 'Enter year' initialAnswer: '') asNumber)).	"Get access to subcanvas from builder and assign it a new Calendar sub-application."
	newCalendar := Calendar
				newOnMonth: month
				year: year
				from: self
				message: #selection:.
	sub := (self builder componentAt: #subcanvas) widget.
	sub client: newCalendar spec: #windowSpec.
	self selection: (Date newDay: 1 month: (Date nameOfMonth: month) year: year)!

saveNotes

	"This stub method was generated by UIDefiner"

	^self!

selection: aDate 
	selectedDate value: aDate.
	note value: (notes at: aDate ifAbsent: [''])! !

!Diary methodsFor: 'aspects'!

note
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^note isNil
		ifTrue:
			[note := String new asValue]
		ifFalse:
			[note]!

notes
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^notes isNil
		ifTrue:
			[notes := String new asValue]
		ifFalse:
			[notes]!

selectedDate
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^selectedDate isNil
		ifTrue:
			[selectedDate := String new asValue]
		ifFalse:
			[selectedDate]! !

!Diary methodsFor: 'initialization'!

initialize
	selectedDate := Date today asValue.
	notes := Dictionary new! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Diary class
	instanceVariableNames: ''!


!Diary class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Diary' 
			#bounds: #(#Rectangle 441 112 760 540 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SubCanvasSpec 
					#layout: #(#Rectangle 15 9 308 247 ) 
					#name: #subcanvas 
					#majorKey: #Calendar 
					#minorKey: #windowSpec 
					#clientKey: #newCalendar ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 12 256 91 284 ) 
					#model: #newDate 
					#label: 'New Date' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 232 256 311 284 ) 
					#model: #saveNotes 
					#label: 'Save Notes' 
					#defaultable: true ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 111 258 211 283 ) 
					#model: #selectedDate 
					#alignment: #center 
					#type: #date 
					#formatString: 'd-mmm-yy' ) 
				#(#TextEditorSpec 
					#layout: #(#Rectangle 15 293 308 415 ) 
					#model: #note 
					#menu: #newMenu ) ) ) )! !

ApplicationModel subclass: #Library
	instanceVariableNames: 'password text '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!Library methodsFor: 'password'!

getPassword
	"The code when using standalone Dialog class: PasswordDialog openFrom: self onClosing: #password:"
	self openDialogInterface: # passwordWindow! !

!Library methodsFor: 'accessing'!

password
	^password!

password: aString 
	password := aString! !

!Library methodsFor: 'aspects'!

text
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^text isNil
		ifTrue:
			[text := String new asValue]
		ifFalse:
			[text]! !

!Library methodsFor: 'actions - closing'!

acceptAndClose

	password := text value.
	Window currentWindow controller close!

cancelAndClose
	password := ''.
	Window currentWindow controller close! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Library class
	instanceVariableNames: ''!


!Library class methodsFor: 'interface specs'!

passwordWindow
	"UIPainter new openOnClass: self andSelector: #passwordWindow"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Password Dialog' 
			#bounds: #(#Rectangle 300 256 500 345 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#LabelSpec 
					#layout: #(#Point 39 8 ) 
					#label: 'Enter your password' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 48 29 148 54 ) 
					#model: #text 
					#type: #password ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 5 61 83 84 ) 
					#model: #acceptAndClose 
					#label: 'Accept' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 116 61 194 84 ) 
					#model: #cancelAndClose 
					#label: 'Cancel' 
					#defaultable: true ) ) ) )! !

ApplicationModel subclass: #LibraryCatalog
	instanceVariableNames: 'bookList selectedBook '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!LibraryCatalog methodsFor: 'actions'!

addBook
	"Get the List object and add a new item of the appropriate kind."

	self bookList list add: Book new!

byAuthor
	"Resort the list by author names and redisplay it."

	bookList list sortWith: [:book1 :book2 | book1 author < book2 author].
	bookList list: bookList list!

byTitle
	"Resort the list by titles and redisplay it."

	bookList list sortWith: [:book1 :book2 | book1 title < book2 title].
	bookList list: bookList list!

byYear
	"Resort the list by years and redisplay it."

	bookList list sortWith: [:book1 :book2 | book1 year < book2 year].
	bookList list: bookList list!

removeBook
	| index |
	index := bookList selectionIndex.
	index = 0 ifTrue: [^self].
	bookList list removeAtIndex: index! !

!LibraryCatalog methodsFor: 'aspects'!

bookList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^bookList isNil
		ifTrue:
			[bookList :=  SelectionInList new.
			bookList selectionIndexHolder compute:
				[:v |
				self selectedBook value: bookList selection].
			bookList]
		ifFalse:
			[bookList]!

selectedBook
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^selectedBook isNil
		ifTrue:
			[selectedBook := nil asValue]
		ifFalse:
			[selectedBook]! !

!LibraryCatalog methodsFor: 'initialization'!

initialize
	"Create and initialize the SelectionInList underlying the dataset widget."

	"Create a List object to hold the data."
	| list authors titles years |
	list := List new.	"Initialize the list - we use three arrays representing columns to do this more compactly."
	authors := #('Kerouac' 'Steinbeck' 'Chandler' 'Christie' 'Homer' 'Kundera').
	titles := #('On the road' 'The grapes of wrath' 'The sleepy blonde' 'Miss Marple remembers' 'Ilias' 'Farewell party').
	years := #(1980 1970 1975 1983 11 1980).
	1 to: authors size do: [:index | "Create the rows."
		list add: (Book
				author: (authors at: index)
				title: (titles at: index)
				year: (years at: index))].	"Create the SelectionInList model of the dataset and assign the list to it."
	bookList := self bookList list: list! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

LibraryCatalog class
	instanceVariableNames: ''!


!LibraryCatalog class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Library Catalog' 
			#bounds: #(#Rectangle 300 200 692 393 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#DataSetSpec 
					#layout: #(#Rectangle 27 11 362 137 ) 
					#flags: 13 
					#model: #bookList 
					#columns: #(
						#(#DataSetColumnSpec 
							#model: #' selectedBook author ' 
							#label: 'Author' 
							#labelIsImage: false 
							#width: 122 
							#editorType: #InputField 
							#noScroll: false ) 
						#(#DataSetColumnSpec 
							#model: #' selectedBook title ' 
							#label: 'Title' 
							#labelIsImage: false 
							#width: 140 
							#editorType: #InputField 
							#noScroll: false ) 
						#(#DataSetColumnSpec 
							#model: #' selectedBook year ' 
							#label: 'Year' 
							#labelIsImage: false 
							#width: 56 
							#editorType: #InputField 
							#type: #number 
							#noScroll: false 
							#formatString: '0' ) ) ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 8 142 104 165 ) 
					#model: #addBook 
					#label: 'Add Book' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 8 168 104 191 ) 
					#model: #removeBook 
					#label: 'Remove Book' 
					#defaultable: true ) 
				#(#GroupBoxSpec 
					#layout: #(#Rectangle 125 136 387 188 ) 
					#label: 'Sort' ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 130 155 208 178 ) 
					#model: #byAuthor 
					#label: 'by author' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 219 155 297 178 ) 
					#model: #byTitle 
					#label: 'by title' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 305 155 383 178 ) 
					#model: #byYear 
					#label: 'by year' 
					#defaultable: true ) ) ) )! !

ApplicationModel subclass: #Calendar
	instanceVariableNames: 'master message month year '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!Calendar methodsFor: 'accessing'!

master: appModel 
	master := appModel!

message: appModel 
	message := appModel!

month: anInteger 
	month := anInteger!

year: anInteger 
	year := anInteger! !

!Calendar methodsFor: 'initialization'!

postBuildWith: aBuilder 
	"Add day buttons to the fixed part of the interface, change label to show month and year."
	"Change date label to display current month and year."

	| xStart yStart width startBox boxNumber x y nameOfMonth startDate lastDay |
	startDate := Date
				newDay: 1
				month: (nameOfMonth := Date nameOfMonth: month)
				year: year.
	(aBuilder componentAt: #date)
		label: (Label with: (nameOfMonth asString , ' ' , year printString) asText allBold).	"Calculate position of first valid button and the number of days in current month."
	startBox := Date dayOfWeek: startDate weekday.	"Number of start box in first row."
	lastDay := Date daysInMonth: nameOfMonth forYear: year.	"Initialize upper level corner coordinates of the leftmost button in the first row."
	xStart := 10.
	yStart := 45.
	y := yStart.
	width := 32.
	boxNumber := 1.
	1 to: 6
		do: 
			[:row | 
			"Execute loop for 6 rows."
			x := xStart.
			1 to: 7
				do: 
					[:column | 
					"First button in the row."
					"7 columns."
					"Number of date for this position in the button array."
					| date |
					date := boxNumber - startBox.
					(boxNumber >= (startBox + 1) and: ["Display only buttons corresponding to valid dates in the month."
						date <= lastDay])
						ifTrue: [aBuilder add: (ActionButtonSpec
									model: [master perform: message with: (Date
												newDay: date
												month: nameOfMonth
												year: year)]
									label: date printString
									layout: (x @ y extent: width @ width))].	"Calculate x position for next button in the row."
					x := x + width.	"Update button number."
					boxNumber := boxNumber + 1].	"Increment y to start of next row."
			y := y + width]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Calendar class
	instanceVariableNames: ''!


!Calendar class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Calendar' 
			#min: #(#Point 295 242 ) 
			#max: #(#Point 295 242 ) 
			#bounds: #(#Rectangle 231 293 526 535 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#LabelSpec 
					#layout: #(#Point 14 0 ) 
					#name: #date 
					#label: 'MonthLabel' ) 
				#(#LabelSpec 
					#layout: #(#Point 23 19 ) 
					#label: 'Su' ) 
				#(#LabelSpec 
					#layout: #(#Point 52 19 ) 
					#label: 'Mo' ) 
				#(#LabelSpec 
					#layout: #(#Point 83 19 ) 
					#label: 'Tu' ) 
				#(#LabelSpec 
					#layout: #(#Point 111 19 ) 
					#label: 'We' ) 
				#(#LabelSpec 
					#layout: #(#Point 143 19 ) 
					#label: 'Th' ) 
				#(#LabelSpec 
					#layout: #(#Point 175 19 ) 
					#label: 'Fr' ) 
				#(#LabelSpec 
					#layout: #(#Point 203 19 ) 
					#label: 'Sa' ) ) ) )! !

!Calendar class methodsFor: 'creation'!

newOnMonth: monthInteger year: yearInteger from: appModel message: aSymbol 
	^(self new) month: monthInteger; year: yearInteger; master: appModel; message: aSymbol! !

Object subclass: #Book
	instanceVariableNames: 'author title year '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'App 2'!


!Book methodsFor: 'accessing'!

author
	^author!

author: aString
	author := aString!

title
	^title!

title: aString
	title := aString!

year
	^year!

year: anInteger
	year := anInteger! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Book class
	instanceVariableNames: ''!


!Book class methodsFor: 'creation'!

author: authorString title: titleString year: anInteger 
	^(self new) author: authorString; title: titleString; year: anInteger! !

