Object subclass: #Animal
	instanceVariableNames: 'color name hungry hungryCount '
	classVariableNames: 'TotalCount '
	poolDictionaries: ''
	category: 'Chapter 1'!


!Animal methodsFor: 'accessing'!

color 
	^color!

color: aString 
	color := aString!

hungry: aBoolean 
	hungry := aBoolean!

hungryCount: integer 
	hungryCount := integer!

isHungry
	hungryCount := hungryCount + 1.
	hungryCount > 2 ifTrue: [hungry := true].
	^hungry printString!

name
	^name!

name: aString 
	name := aString! !

!Animal methodsFor: 'actions'!

eat
	hungry := false.
	hungryCount := 0.
	^'hungry  = false'!

run
	^'I am running'!

walk
	^'I am walking'! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Animal class
	instanceVariableNames: 'SpeciesCount '!


!Animal class methodsFor: 'counting'!

incrementSpeciesCount
	SpeciesCount := SpeciesCount + 1!

incrementTotalCount
	TotalCount := TotalCount + 1!

resetCounts
	TotalCount := 0.
	self allSubclassesDo: [:subclass | subclass resetSpeciesCount]!

resetSpeciesCount
	SpeciesCount := 0! !

!Animal class methodsFor: 'counts'!

speciesCount
	^SpeciesCount!

totalCount
	^TotalCount! !

!Animal class methodsFor: 'private'!

creatureName
	self subclassResponsibility! !

!Animal class methodsFor: 'creation'!

color: colorString name: nameString 
	SpeciesCount isNil ifTrue: [SpeciesCount := 0].
	SpeciesCount := SpeciesCount + 1.
	TotalCount isNil ifTrue: [TotalCount := 0].
	TotalCount := TotalCount + 1.
	^(super new) color: colorString; name: nameString; hungry: true; hungryCount: 0!

new
	SpeciesCount isNil ifTrue: [SpeciesCount := 0].
	SpeciesCount := SpeciesCount + 1.
	TotalCount isNil ifTrue: [TotalCount := 0].
	TotalCount := TotalCount + 1.
	^(super new) color: (Dialog request: 'Enter color' initialAnswer: ''); name: (Dialog request: 'Enter color' initialAnswer: ''); hungry: true; hungryCount: 0! !

Animal subclass: #Cow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Cow methodsFor: 'communicating'!

moo
	^'I moo'! !

!Cow methodsFor: 'converting'!

asString
	^'cow'! !

!Cow methodsFor: 'actions'!

run
	^'I am too full'! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Cow class
	instanceVariableNames: ''!


!Cow class methodsFor: 'private'!

creatureName
	^'person'! !

!Cow class methodsFor: 'converting'!

asString
	^'Cow'! !

Animal subclass: #Cat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Cat methodsFor: 'communicating'!

meow
	^'I meow'! !

!Cat methodsFor: 'converting'!

asString
	^'cat'! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Cat class
	instanceVariableNames: ''!


!Cat class methodsFor: 'private'!

creatureName
	^'cat'! !

!Cat class methodsFor: 'converting'!

asString
	^'Cat'! !

ApplicationModel subclass: #Farm
	instanceVariableNames: 'expression result object selectedAnimal selectedMessage objectsAndMessages animals animalNames animalList messages messageList program message calculatedName totalCows totalAnimals totalDogs totalCats farm help currentClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Farm methodsFor: 'aspects'!

animalList
	^animalList!

animals
	^animals!

expression
	^expression!

farm
	^farm!

message
	^message!

messageList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^messageList isNil
		ifTrue:
			[messageList := SelectionInList new]
		ifFalse:
			[messageList]!

object
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^object isNil
		ifTrue:
			[object := String new asValue]
		ifFalse:
			[object]!

program
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^program isNil
		ifTrue:
			[program := String new asValue]
		ifFalse:
			[program]!

result
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^result isNil
		ifTrue:
			[result := String new asValue]
		ifFalse:
			[result]!

selectedObject
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^selectedObject isNil
		ifTrue:
			[selectedObject := String new asValue]
		ifFalse:
			[selectedObject]!

totalAnimals
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."

	^totalAnimals!

totalCats
	"This method was generated by UIDefiner. Any edits made here 
	may be lost whenever methods are automatically defined."

	^totalCats!

totalCows
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."

	^totalCows!

totalDogs
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."

	^totalDogs!

totalsCats
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."

	^totalsCats! !

!Farm methodsFor: 'changes'!

newAnimal
	| index |
	selectedAnimal := (index := animalList selectionIndex) = 0
				ifTrue: [nil]
				ifFalse: [animals at: index].
	selectedAnimal isNil
		ifTrue: [messageList list: #()]
		ifFalse: 
			[| animalName |
			animalName := animalList selection.
			messageList list: (objectsAndMessages at: selectedAnimal asString).
			self displayAnimal: animalName.
			(self builder componentAt: #animalList) disable]!

newMessage
	| returned |
	(selectedMessage := messageList selection) isNil
		ifFalse: 
			[returned := selectedAnimal perform: selectedMessage.
			selectedAnimal isBehavior
				ifTrue: 
					[animalNames add: (self calculateNameFor: returned asString).
					animals add: returned].
			self displayMessage: returned.
			animalList list: animalNames.
			(self builder componentAt: #animalList) enable.
			messageList list: #()]! !

!Farm methodsFor: 'actions'!

openFarm
	(Smalltalk at: farm value) open! !

!Farm methodsFor: 'initialization'!

initialize
	farm := #Farm1 asValue.
	currentClass := self classFor: #Farm1.
	help := currentClass help asValue.
	farm onChangeSend: #helpText to: self! !

!Farm methodsFor: 'private'!

calculateNameFor: animalName 
	calculatedName := animalName
				copyReplaceFrom: 1
				to: 1
				with: (String with: (animalName at: 1) asLowercase).
	^calculatedName := calculatedName , (Smalltalk at: animalList selection asSymbol) speciesCount printString!

classFor: aSymbol 
	^Smalltalk at: aSymbol!

displayAnimal: animal 
	| name |
	name := animal.
	name first isUppercase ifTrue: [name := name , ' class'].
	expression value: name.
	object value: name asString.
	message value: ''.
	result value: ''!

displayMessage: returnedResult 
	result value: returnedResult asString.
	message value: selectedMessage.
	expression value: expression value , ' ' , selectedMessage!

help
	^help!

helpText
	help value: (self classFor: farm value) help!

interfaceSpecForKind: anInteger 
	^(anInteger between: 1 and: 3)
		ifTrue: [#farm1Spec]
		ifFalse: [#farm2Spec]!

updateTotalCats
	totalCats value: Cat speciesCount!

updateTotalCows
	totalCows value: Cow speciesCount!

updateTotalDogs
	totalDogs value: Dog speciesCount! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Farm class
	instanceVariableNames: ''!


!Farm class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Farm launcher' 
			#min: #(#Point 353 144 ) 
			#max: #(#Point 353 144 ) 
			#bounds: #(#Rectangle 224 228 577 372 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 113 112 179 137 ) 
					#model: #openFarm 
					#label: 'Open' 
					#defaultable: true ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 14 7 ) 
					#model: #farm 
					#label: 'Farm 1' 
					#select: #Farm1 ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 14 30 ) 
					#model: #farm 
					#label: 'Farm 2' 
					#select: #Farm2 ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 14 53 ) 
					#model: #farm 
					#label: 'Farm 3' 
					#select: #Farm3 ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 14 76 ) 
					#model: #farm 
					#label: 'Farm 4' 
					#select: #Farm4 ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 14 99 ) 
					#model: #farm 
					#label: 'Farm 5' 
					#select: #Farm5 ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 14 122 ) 
					#model: #farm 
					#label: 'Farm 6' 
					#select: #Farm6 ) 
				#(#TextEditorSpec 
					#layout: #(#Rectangle 88 49 346 106 ) 
					#flags: 12 
					#model: #help ) 
				#(#LabelSpec 
					#layout: #(#Point 130 18 ) 
					#label: 'Description of selected Farm' ) ) ) )! !

Farm subclass: #Farm1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Farm1 methodsFor: 'initialization'!

initialize
	messageList := SelectionInList with: #().
	messageList selectionIndexHolder onChangeSend: #newMessage to: self.
	objectsAndMessages := Dictionary withKeysAndValues: #('cat' #(#isHungry #meow #eat #run #walk) 'dog' #(#isHungry #bark #eat #run #walk) 'cow' #(#isHungry #moo #eat #run #walk)).
	expression := '' asValue.
	message := '' asValue.
	animalNames := #('cat' 'cow' 'dog').
	animalList := SelectionInList with: animalNames.
	animalList selectionIndexHolder onChangeSend: #newAnimal to: self.
	animals := Array
				with: (Cat color: 'white' name: 'Pussie')
				with: (Cow color: 'brown' name: 'Jerky')
				with: (Dog color: 'black' name: 'Rob')!

postBuildWith: aBuilder 
	aBuilder window label: ('Farm ' copyWith: (self class name at: 5))! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Farm1 class
	instanceVariableNames: ''!


!Farm1 class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Model 1' 
			#min: #(#Point 602 184 ) 
			#max: #(#Point 602 184 ) 
			#bounds: #(#Rectangle 99 208 701 392 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#LabelSpec 
					#layout: #(#Point 383 67 ) 
					#name: #object 
					#label: 'Receiver' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 463 68 553 90 ) 
					#model: #object 
					#isReadOnly: true ) 
				#(#GroupBoxSpec 
					#layout: #(#Rectangle 375 4 597 174 ) 
					#label: 'Operation' ) 
				#(#LabelSpec 
					#layout: #(#Point 383 141 ) 
					#label: 'Result' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 463 141 590 163 ) 
					#model: #result 
					#isReadOnly: true ) 
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 9 27 175 174 ) 
					#name: #animalList 
					#model: #animalList 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#LabelSpec 
					#layout: #(#Point 35 1 ) 
					#label: 'Message Receivers' ) 
				#(#LabelSpec 
					#layout: #(#Point 245 1 ) 
					#label: 'Messages' ) 
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 191 27 359 174 ) 
					#model: #messageList 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 387 26 590 48 ) 
					#model: #expression ) 
				#(#LabelSpec 
					#layout: #(#Point 383 100 ) 
					#label: 'Message' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 463 99 553 121 ) 
					#model: #message ) ) ) )! !

!Farm1 class methodsFor: 'help'!

help
	^'I introduce the concept of objects and messages.'! !

Animal subclass: #Dog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Dog methodsFor: 'communicating'!

bark
	^'I bark'! !

!Dog methodsFor: 'converting'!

asString
	^'dog'! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Dog class
	instanceVariableNames: ''!


!Dog class methodsFor: 'private'!

creatureName
	^'dog'! !

!Dog class methodsFor: 'converting'!

asString
	^'Dog'! !

Farm1 subclass: #Farm2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Farm2 methodsFor: 'initialization'!

initialize
	super initialize.
	objectsAndMessages add: 'cat' -> #(#color #name #isHungry #meow #eat #run #walk); add: 'dog' -> #(#color #name #isHungry #bark #eat #run #walk); add: 'cow' -> #(#color #name #isHungry #moo #eat #run #walk)! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Farm2 class
	instanceVariableNames: ''!


!Farm2 class methodsFor: 'help'!

help
	^'I add the concept of object properites to the concepts of objects and messages.'! !

Farm2 subclass: #Farm3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Farm3 methodsFor: 'initialization'!

initialize
	super initialize.
	objectsAndMessages add: 'Cat' -> #(#new); add: 'Dog' -> #(#new); add: 'Cow' -> #(#new).
	expression := '' asValue.
	message := '' asValue.
	animals := OrderedCollection
				with: Cat
				with: Cow
				with: Dog.
	animalNames := OrderedCollection
				with: 'Cat'
				with: 'Cow'
				with: 'Dog'.
	animalList := SelectionInList with: animalNames.
	animalList selectionIndexHolder onChangeSend: #newAnimal to: self.
	Animal resetCounts! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Farm3 class
	instanceVariableNames: ''!


!Farm3 class methodsFor: 'help'!

help
	^'I introduce the concept of a class.'! !

Farm3 subclass: #Farm4
	instanceVariableNames: 'body '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Farm4 methodsFor: 'initialization'!

initialize
	super initialize.
	body := ''! !

!Farm4 methodsFor: 'private'!

displayAnimal: animal 
	body isEmpty ifFalse: [body := body , '.' , (String with: Character cr)].
	body := body , animalList selection.
	result value: ''!

displayMessage: returnedResult 
	program value: (body := body , ' ' , selectedMessage).
	result value: returnedResult asString! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Farm4 class
	instanceVariableNames: ''!


!Farm4 class methodsFor: 'help'!

help
	^'I introduce the basic look of a Smalltalk program.'! !

!Farm4 class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Model 2' 
			#min: #(#Point 602 173 ) 
			#max: #(#Point 602 173 ) 
			#bounds: #(#Rectangle 99 214 701 387 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 7 27 175 127 ) 
					#name: #animalList 
					#model: #animalList 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#LabelSpec 
					#layout: #(#Point 34 1 ) 
					#label: 'Message Receivers' ) 
				#(#LabelSpec 
					#layout: #(#Point 245 1 ) 
					#label: 'Messages' ) 
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 191 27 359 127 ) 
					#model: #messageList 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#TextEditorSpec 
					#layout: #(#Rectangle 375 27 588 127 ) 
					#model: #program ) 
				#(#LabelSpec 
					#layout: #(#Point 429 1 ) 
					#label: 'Smalltalk program' ) 
				#(#LabelSpec 
					#layout: #(#Point 379 141 ) 
					#label: 'Result' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 427 140 554 162 ) 
					#model: #result 
					#isReadOnly: true ) ) ) )! !

Farm4 subclass: #Farm5
	instanceVariableNames: 'variables '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Farm5 methodsFor: 'initialization'!

initialize
	super initialize.
	variables := OrderedCollection new! !

!Farm5 methodsFor: 'private'!

displayAnimal: animal!

displayMessage: returnedResult 
	| declaration selectedAnimalName |
	selectedAnimalName := selectedAnimal asString.
	body isEmpty ifFalse: [body := body , '.' , (String with: Character cr)].
	(selectedAnimalName asString at: 1) isUppercase
		ifTrue: 
			[variables := variables , calculatedName , ' '.
			body := body , calculatedName , ' := '].
	body := body , selectedAnimalName.
	declaration := variables isEmpty
				ifTrue: ['']
				ifFalse: ['| ' , variables , '|' , (String with: Character cr)].
	program value: declaration , (body := body , ' ' , selectedMessage).
	result value: returnedResult asString! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Farm5 class
	instanceVariableNames: ''!


!Farm5 class methodsFor: 'help'!

help
	^'I introduce the concept of variables and their declaration.'! !

Farm5 subclass: #Farm6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 1'!


!Farm6 methodsFor: 'initialization'!

initialize
	super initialize.
	totalAnimals := 0 asValue.
	totalCats := 0 asValue.
	totalCows := 0 asValue.
	totalDogs := 0 asValue.
	Animal resetCounts! !

!Farm6 methodsFor: 'changes'!

newMessage
	| returned |
	(selectedMessage := messageList selection) isNil
		ifFalse: 
			[returned := selectedAnimal perform: selectedMessage.
			selectedAnimal isBehavior
				ifTrue: 
					[animalNames add: (self calculateNameFor: returned asString).
					animals add: returned.
					totalAnimals value: returned class totalCount.
					self perform: ('updateTotal' , returned class name , 's') asSymbol].
			self displayMessage: returned.
			animalList list: animalNames.
			(self builder componentAt: #animalList) enable.
			messageList list: #()]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Farm6 class
	instanceVariableNames: ''!


!Farm6 class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Model 3' 
			#min: #(#Point 602 232 ) 
			#max: #(#Point 602 232 ) 
			#bounds: #(#Rectangle 99 184 701 416 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 7 27 175 127 ) 
					#name: #animalList 
					#model: #animalList 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#LabelSpec 
					#layout: #(#Point 34 1 ) 
					#label: 'Message Receivers' ) 
				#(#LabelSpec 
					#layout: #(#Point 245 1 ) 
					#label: 'Messages' ) 
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 191 27 359 127 ) 
					#model: #messageList 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#TextEditorSpec 
					#layout: #(#Rectangle 375 27 588 127 ) 
					#model: #program ) 
				#(#LabelSpec 
					#layout: #(#Point 429 1 ) 
					#label: 'Smalltalk program' ) 
				#(#LabelSpec 
					#layout: #(#Point 373 140 ) 
					#label: 'Result' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 425 139 552 161 ) 
					#model: #result 
					#isReadOnly: true ) 
				#(#LabelSpec 
					#layout: #(#Point 19 139 ) 
					#label: 'Total animals' ) 
				#(#LabelSpec 
					#layout: #(#Point 208 140 ) 
					#label: 'Total cats' ) 
				#(#LabelSpec 
					#layout: #(#Point 208 168 ) 
					#label: 'Total cows' ) 
				#(#LabelSpec 
					#layout: #(#Point 208 196 ) 
					#label: 'Total dogs' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 295 140 334 163 ) 
					#model: #totalCats 
					#alignment: #center 
					#isReadOnly: true 
					#type: #number ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 294 167 333 190 ) 
					#model: #totalCows 
					#alignment: #center 
					#isReadOnly: true 
					#type: #number ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 294 194 333 217 ) 
					#model: #totalDogs 
					#alignment: #center 
					#isReadOnly: true 
					#type: #number ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 107 139 146 162 ) 
					#model: #totalAnimals 
					#alignment: #center 
					#isReadOnly: true 
					#type: #number ) ) ) )! !

!Farm6 class methodsFor: 'help'!

help
	^'I illustrate the concepts of a class variable and a class instance variable.'! !

