View subclass: #ImageView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!


!ImageView methodsFor: 'controller accessing'!

defaultControllerClass
	^NoController! !

!ImageView methodsFor: 'displaying'!

displayOn: aGraphicsContext 
	| string width center |
	model image isNil
		ifTrue: 
			[center := self bounds center.
			string := 'Click action button'.
			width := aGraphicsContext widthOfString: string.
			aGraphicsContext displayString: string at: center x - (width / 2) @ 30.
			string := 'to display image'.
			width := aGraphicsContext widthOfString: string.
			^aGraphicsContext displayString: string at: center x - (width / 2) @ 50].
	aGraphicsContext displayImage: model image at: 0 @ 0! !

ApplicationModel subclass: #TwoImages
	instanceVariableNames: 'image image1 image2 imageView '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!


!TwoImages methodsFor: 'initialization'!

initialize
	Dialog warn: 'Select the first image on screen.'.
	image1 := Image fromUser.
	Dialog warn: 'Select the second image on screen.'.
	image2 := Image fromUser.
	imageView := ImageView new.
	imageView model: self! !

!TwoImages methodsFor: 'actions'!

image1
	self image: image1!

image2
	self image: image2! !

!TwoImages methodsFor: 'accessing'!

image
	^image!

image: anImage 
	image := anImage.
	self changed!

imageView
	^imageView! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

TwoImages class
	instanceVariableNames: ''!


!TwoImages class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Two images' 
			#bounds: #(#Rectangle 300 200 500 400 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#ArbitraryComponentSpec 
					#layout: #(#Rectangle 5 9 195 154 ) 
					#component: #imageView ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 24 162 84 187 ) 
					#model: #image1 
					#label: 'Image 1' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 106 162 166 187 ) 
					#model: #image2 
					#label: 'Image 2' 
					#defaultable: true ) ) ) )! !

ApplicationModel subclass: #Patterns
	instanceVariableNames: 'paint '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!


!Patterns methodsFor: 'initialization'!

initialize
	paint := ColorValue black! !

!Patterns methodsFor: 'actions'!

color
	| colorName |
	colorName := Dialog
				choose: 'Choose color'
				fromList: ColorValue constantNames
				values: ColorValue constantNames
				lines: 8
				cancel: [nil].
	colorName isNil ifFalse: [paint := ColorValue perform: colorName]!

draw
	"Obtain informtion about a square from user and draw the square with current paint."

	| startx starty side gc |
	gc := self builder window graphicsContext.
	gc paint: paint.
	startx := (Dialog request: 'Upper left x' initialAnswer: '30') asNumber.
	starty := (Dialog request: 'Upper left y' initialAnswer: '30') asNumber.
	side := (Dialog request: 'Side' initialAnswer: '20') asNumber.
	^gc displayRectangle: (startx @ starty extent: side @ side)!

pattern
	Dialog warn: 'Select a rectangle on the screen'.
	paint := Screen default contentsFromUser asPattern! !

!Patterns methodsFor: 'aspects'!

paint
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^paint isNil
		ifTrue:
			[paint := nil asValue]
		ifFalse:
			[paint]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Patterns class
	instanceVariableNames: ''!


!Patterns class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Test 2' 
			#bounds: #(#Rectangle 220 140 420 340 ) ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 129 170 181 195 ) 
					#model: #draw 
					#label: 'Draw' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 17 170 69 195 ) 
					#model: #color 
					#label: 'Color' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 73 170 125 195 ) 
					#model: #pattern 
					#label: 'Pattern' 
					#defaultable: true ) ) ) )! !

ControllerWithMenu subclass: #ClickableController
	instanceVariableNames: 'cursor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!


!ClickableController methodsFor: 'accessing'!

cursor
	^cursor isNil
		ifTrue: [Cursor currentCursor]
		ifFalse: [cursor]! !

!ClickableController methodsFor: 'events'!

enterEvent: anEvent 
	model state isNil ifFalse: 
			[cursor := Cursor currentCursor.
			Cursor crossHair show]!

exitEvent: anEvent 
	model state isNil ifFalse: [self cursor show]!

redButtonPressedEvent: event 
	"Send message to model with point coordinates."

	| position |
	position := self sensor cursorPointFor: event.
	 model executeOperationWith: position! !

ApplicationModel subclass: #DrawObjects
	instanceVariableNames: 'color clippingRectangle object width '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!
DrawObjects comment:
'I implement an illustration of the use of GraphicsContext in Chapter 12.

Instance variables:

color				<ColorValue>	used for drawing
clippingRectangle	<Rectangle>	rectangle within window clipping drawing
object				<Geometric>	object being drawn
width '!


!DrawObjects methodsFor: 'drawing'!

drawCircleOn: aGraphicsContext 
	"Get center coordinates and radius from user, draw a circle."
	"Obtain coordinates from user."

	| centerx centery radius |
	centerx := (Dialog request: 'Center x' initialAnswer: '30') asNumber.
	centery := (Dialog request: 'Center y' initialAnswer: '30') asNumber.
	radius := (Dialog request: 'Radius' initialAnswer: '20') asNumber.	"Draw unfilled circle inside the clipping rectangle using current parameter settings."
	^aGraphicsContext displayDotOfDiameter: radius at: centerx @ centery!

drawLineOn: aGraphicsContext 
	"Get center coordinates and radius from user, draw a circle."
	"Obtain coordinates from user."

	| startx starty endx endy |
	startx := (Dialog request: 'Start x' initialAnswer: '30') asNumber.
	starty := (Dialog request: 'Start y' initialAnswer: '30') asNumber.
	endx := (Dialog request: 'End x' initialAnswer: '50') asNumber.
	endy := (Dialog request: 'End y' initialAnswer: '50') asNumber.	
	"Draw unfilled circle inside the clipping rectangle using current parameter settings."
	^aGraphicsContext displayLineFrom: startx @ starty to: endx @ endy!

drawSquareOn: aGraphicsContext 
	"Get origin coordinates and side length from user, draw a square."

	"Obtain origin and side of square from user."
	| startx starty side |
	startx := (Dialog request: 'Upper left x' initialAnswer: '30') asNumber.
	starty := (Dialog request: 'Upper left y' initialAnswer: '30') asNumber.
	side := (Dialog request: 'Side' initialAnswer: '20') asNumber.	"Draw unfilled square inside the clipping rectangle using current parameter settings."
	^aGraphicsContext displayRectangularBorder: (startx @ starty extent: side @ side)!

drawStringOn: aGraphicsContext 
	"Get center coordinates and radius from user, draw a circle."
	"Obtain coordinates from user."

	| startx starty string |
	startx := (Dialog request: 'Start x' initialAnswer: '30') asNumber.
	starty := (Dialog request: 'Start y' initialAnswer: '30') asNumber.
	string := Dialog request: 'Enter string' initialAnswer: ''.
	"Draw string inside the clipping rectangle using current parameter settings."
	^aGraphicsContext displayString: string at: startx @ starty! !

!DrawObjects methodsFor: 'actions'!

color
	"Get color from user and save it."

	| colorName |
	colorName := Dialog
				choose: 'Choose color'
				fromList: ColorValue constantNames
				values: ColorValue constantNames
				lines: 8
				cancel: ["Names of built-in named colors."
					nil].
	colorName isNil ifFalse: [color := ColorValue perform: colorName]!

draw
	"Get graphics context, set its parameters, and execute appropriate drawing message."

	| gc |
	gc := self builder window graphicsContext.
	gc paint: color.
	gc lineWidth: width; clippingRectangle: clippingRectangle.
	self perform: ('draw' , object value , 'On:') asSymbol with: gc! !

!DrawObjects methodsFor: 'initialization'!

initialize
	"Set initial parameters for graphics context."

	clippingRectangle := 20 @ 20 corner: 180 @ 100.	"Upper part of the window."
	color := ColorValue black.	"Default color."
	object := #Line asValue.	"Aspect variable of the radio button group."
	width := 1! !

!DrawObjects methodsFor: 'aspects'!

object
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined."

	^object! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DrawObjects class
	instanceVariableNames: ''!


!DrawObjects class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Test1' 
			#bounds: #(#Rectangle 300 200 530 400 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#RadioButtonSpec 
					#layout: #(#Point 17 110 ) 
					#model: #object 
					#label: 'String' 
					#select: #String ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 17 127 ) 
					#model: #object 
					#label: 'Circle' 
					#select: #Circle ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 17 144 ) 
					#model: #object 
					#label: 'Square' 
					#select: #Square ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 17 161 ) 
					#model: #object 
					#label: 'Line' 
					#select: #Line ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 116 117 168 142 ) 
					#model: #color 
					#label: 'Color' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 116 155 168 180 ) 
					#model: #draw 
					#label: 'Draw' 
					#defaultable: true ) ) ) )! !

ApplicationModel subclass: #ClickableImage
	instanceVariableNames: 'controller hotSpots hotSpotName imageView state '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!


!ClickableImage methodsFor: 'hot spots'!

addHotSpot
	"Create hot spot with user-supplied name, add it to collection, and pass control to controller."

	hotSpotName := Dialog request: 'Enter hot spot name'.
	state := #addHotSpotAt:!

addHotSpotAt: aPoint 
	"Complete the hot spot with coordinates."

	state := nil.
	controller cursor show.
	hotSpots add: (Array with: aPoint with: hotSpotName).
	controller menuHolder value: self menuWithRemove!

hotSpotAt: aPoint 
	"Is aPoint within 2 pixels from a hot spot? If so, return it."

	^hotSpots detect: [:hotSpot | aPoint - (hotSpot at: 1) <= (2 @ 2)]
		ifNone: [nil]!

removeHotSpot
	"Create hot spot with user-supplied name, add it to collection, and pass control to controller."

	state := #removeHotSpotAt:!

removeHotSpotAt: aPoint 
	"Complete the hot spot with coordinates."

	| hotSpot |
	state := nil.
	controller cursor show.
	(hotSpot := self hotSpotAt: aPoint) isNil ifTrue: [^Dialog warn: 'Not a hot spot'].
	Dialog warn: 'Hot spot to be removed: ' , (hotSpot at: 2).
	hotSpots remove: hotSpot.
	hotSpots isEmpty ifTrue: [controller menuHolder value: self menuWithAdd]! !

!ClickableImage methodsFor: 'accessing'!

hotSpots
	^hotSpots!

imageView
	^imageView!

state
	^state! !

!ClickableImage methodsFor: 'menus'!

menuWithAdd
	| mb |
	mb := MenuBuilder new.
	mb add: 'add hot spot' -> #addHotSpot.
	^mb menu!

menuWithRemove
	| mb |
	mb := MenuBuilder new.
	mb add: 'add hot spot' -> #addHotSpot; add: 'remove hot spot' -> #removeHotSpot.
	^mb menu! !

!ClickableImage methodsFor: 'initialization'!

initialize
	hotSpots := OrderedCollection new.
	imageView := ClickableView new.
	(controller := imageView controller) performer: self.
	controller menuHolder value: self menuWithAdd.
	imageView model: self! !

!ClickableImage methodsFor: 'execution'!

executeOperationWith: aPoint 
	state isNil ifFalse: [self perform: state with: aPoint. self changed]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClickableImage class
	instanceVariableNames: ''!


!ClickableImage class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Clickable image' 
			#bounds: #(#Rectangle 300 200 500 400 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#ArbitraryComponentSpec 
					#layout: #(#Rectangle 7 6 195 190 ) 
					#component: #imageView ) ) ) )! !

View subclass: #ClickableView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!


!ClickableView methodsFor: 'displaying'!

displayOn: aGraphicsContext 
	model hotSpots do: [:hotSpot | aGraphicsContext paint: ColorValue red; displayRectangle: ((hotSpot at: 1) -2
				extent: 4 @ 4)]! !

!ClickableView methodsFor: 'controller accessing'!

defaultControllerClass
	^ClickableController! !

ApplicationModel subclass: #GeometricFigures
	instanceVariableNames: 'drawingView object '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!


!GeometricFigures methodsFor: 'actions'!

draw
"To redraw the subview, trigger the dependency mechanism."
	self changed! !

!GeometricFigures methodsFor: 'accessing'!

currentObject
	"Use currently selected radio button value to obtain the corresponding geometric object."

	^self perform: object value!

drawingView
	^drawingView! !

!GeometricFigures methodsFor: 'object accessing'!

circle
	^(Circle center: 0@0 radius: 50) asStroker!

ellipse
	^(EllipticalArc boundingBox: (-50 @ -20 corner: 50 @ 20)) asStroker!

line1
	^(LineSegment from: -50 @ -50 to: 50 @ 50) asStroker!

line2
	^(LineSegment from: 50 @ -50 to: -50 @ 50) asStroker!

polyline
	^(Polyline vertices: (Array
			with: -60 @ -30
			with: 30 @ 0
			with: 60 @ 30
			with: -60 @ -30)) asStroker!

rectangle
	^(Rectangle origin: -60 @ -30 corner: 60 @ 30) asStroker!

square
	^(Rectangle origin: -50 @ -50 corner: 50 @ 50) asStroker!

wedge
"Return a displayable rectangle. The coordinates are calculated on the premise fact that the view displays the object in the center."
	^(EllipticalArc
		boundingBox: (-50 @ -20 corner: 50 @ 20)
		startAngle: 0.0
		sweepAngle: 300.0) asFiller! !

!GeometricFigures methodsFor: 'aspects'!

object
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^object isNil
		ifTrue:
			[object := nil asValue]
		ifFalse:
			[object]! !

!GeometricFigures methodsFor: 'initialization'!

initialize
"Select the top radio button, create a binding to the subview, and define yourself as the subview's model."
	object := #rectangle asValue.	"Initial selection when the window opens."
	drawingView := GeometricView new.
	drawingView model: self! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GeometricFigures class
	instanceVariableNames: ''!


!GeometricFigures class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Geometric Figures' 
			#bounds: #(#Rectangle 363 270 632 485 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#ArbitraryComponentSpec 
					#layout: #(#Rectangle 12 12 163 163 ) 
					#component: #drawingView ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 61 176 113 201 ) 
					#model: #draw 
					#label: 'Draw' 
					#defaultable: true ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 175 10 ) 
					#model: #object 
					#label: 'Line 1' 
					#select: #line1 ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 175 29 ) 
					#model: #object 
					#label: 'Line 2' 
					#select: #line2 ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 175 48 ) 
					#model: #object 
					#label: 'Square' 
					#select: #square ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 175 67 ) 
					#model: #object 
					#label: 'Rectangle' 
					#select: #rectangle ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 175 86 ) 
					#model: #object 
					#label: 'Polyline' 
					#select: #polyline ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 175 105 ) 
					#model: #object 
					#label: 'Circle' 
					#select: #circle ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 175 124 ) 
					#model: #object 
					#label: 'Ellipse' 
					#select: #ellipse ) 
				#(#RadioButtonSpec 
					#layout: #(#Point 175 143 ) 
					#model: #object 
					#label: 'Wedge' 
					#select: #wedge ) ) ) )! !

View subclass: #GeometricView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 12'!


!GeometricView methodsFor: 'displaying'!

displayOn: aGraphicsContext 
"Obtain currently selected geometric object and display it in the center of the view."
	aGraphicsContext display: model currentObject at: self bounds center! !

