Magnitude subclass: #Currency
	instanceVariableNames: 'cents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 5'!


!Currency methodsFor: 'creation'!

dollars: dollarsInteger cents: centsInteger 
	cents := 100 * dollarsInteger + centsInteger! !

!Currency methodsFor: 'arithmetic'!

* anInteger 
	^self class cents: cents * anInteger!

+ aCurrency 
	^self class cents: cents + aCurrency cents! !

!Currency methodsFor: 'comparison'!

< aCurrency 
	^cents < aCurrency cents!

= aCurrency 
	^self cents = aCurrency cents!

hash
	^cents hash! !

!Currency methodsFor: 'accessing'!

cents
	^cents!

cents: anInteger
	cents := anInteger!

dollars
	^cents quo: 100! !

!Currency methodsFor: 'printing'!

displayString
	"Append to the argument, aStream, the description of a Currency."

	^self dollars printString , ' dollars, ' , (cents rem: 100) printString , ' cents'!

printOn: aStream 
	"Append to the argument, aStream, the description of a Currency."

	aStream nextPutAll: self class name , ' ', self dollars printString , ' dollars, ' , (cents rem: 100) printString , ' cents, '! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Currency class
	instanceVariableNames: ''!


!Currency class methodsFor: 'creation'!

cents: cents 
	^self new cents: cents!

dollars: dollars cents: cents 
	^self new dollars: dollars cents: cents! !

Rectangle subclass: #AnyRectangle
	instanceVariableNames: 'angle '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 5'!


!AnyRectangle methodsFor: 'accessing'!

angle
	^angle!

angle: aNumber
	angle := aNumber!

bottomLeftCorner
	^origin + (self height * angle sin @ (self height * angle cos))!

topRightCorner
	^origin + ((self width * angle cos) @ (self width * angle sin) negated)! !

!AnyRectangle methodsFor: 'displaying'!

displayStrokedOn: aGraphicsContext 
	"Stroke the receiver on the supplied GraphicsContext."

	| topRightCorner bottomLeftCorner bottomRightCorner |
	topRightCorner := self topRightCorner.
	bottomLeftCorner := self bottomLeftCorner.
	bottomRightCorner := topRightCorner + bottomLeftCorner - origin.
	aGraphicsContext displayLineFrom: origin to: topRightCorner.
	aGraphicsContext displayLineFrom: topRightCorner to: bottomRightCorner.
	aGraphicsContext displayLineFrom: bottomRightCorner to: bottomLeftCorner.
	aGraphicsContext displayLineFrom: bottomLeftCorner to: origin! !

!AnyRectangle methodsFor: 'printing'!

printOn: aStream 
"Append to the argument aStream a sequence of characters that identifies the receiver. The general format is originPoint corner: cornerPoint angle: angle."
	super printOn: aStream.
	aStream nextPutAll: ' angle: '.
	angle printOn: aStream! !

!AnyRectangle methodsFor: 'transforming'!

rotateByAngle: aNumber 
	angle := angle + aNumber! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AnyRectangle class
	instanceVariableNames: ''!


!AnyRectangle class methodsFor: 'creation'!

origin: point1 corner: point2 angle: radians
"Create a rectangle with three corners."
	^self new origin: point1; corner: point2; angle: radians! !

