ApplicationModel subclass: #ClassDefBrowser
	instanceVariableNames: 'definition classList '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 8'!


!ClassDefBrowser methodsFor: 'aspects'!

classList
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^classList isNil
		ifTrue:
			[classList := SelectionInList new]
		ifFalse:
			[classList]!

definition
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^definition isNil
		ifTrue:
			[definition := String new asValue]
		ifFalse:
			[definition]! !

!ClassDefBrowser methodsFor: 'changes'!

changedClass
	"Class selection has changed. Blank the text view or display the definition of the selected class."

	classList selection isNil
		ifTrue: [definition value: '']
		ifFalse: ["Nothing selected in the list view - blank the text editor."
			definition value: (Smalltalk at: classList selection asSymbol) definition]! !

!ClassDefBrowser methodsFor: 'initialization'!

initialize
	"Define the list holder for the list widget and register interest in selection changes."

	classList := SelectionInList with: Smalltalk classNames.
	classList selectionIndexHolder onChangeSend: #changedClass to: self! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassDefBrowser class
	instanceVariableNames: ''!


!ClassDefBrowser class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Classes' 
			#bounds: #(#Rectangle 276 164 682 471 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 61 30 342 146 ) 
					#model: #classList 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#TextEditorSpec 
					#layout: #(#Rectangle 6 171 397 305 ) 
					#model: #definition ) 
				#(#LabelSpec 
					#layout: #(#Point 172 8 ) 
					#label: 'Definition' ) 
				#(#LabelSpec 
					#layout: #(#Point 178 150 ) 
					#label: 'Classes' ) ) ) )! !

ApplicationModel subclass: #Court
	instanceVariableNames: 'ball courtWidth courtLength spectators numberOfMoves numberOfSpectators '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 8'!


!Court methodsFor: 'accessing'!

ball

	^ball!

ball: aValue

	ball := aValue!

courtLength: aValue

	courtLength := aValue!

courtWidth: aValue

	courtWidth := aValue!

spectators

	^spectators!

spectators: aValue

	spectators := aValue! !

!Court methodsFor: 'initialization'!

initialize
	courtLength := 10 asValue.
	courtWidth := 10 asValue.
	ball := Ball onCourt: self.
	numberOfSpectators := 5 asValue.
	numberOfMoves := 20 asValue.
	self reset!

reset
	| distance |
	1 to: spectators size do: [:index | self ball removeDependent: (spectators at: index)].
	spectators := Array new: self numberOfSpectators value.
	distance := (courtLength value / spectators size) truncated.
	1 to: spectators size do: [:index | spectators at: index put: (Spectator court: self location: 1 + (distance * (index - 1)))].
	spectators do: [:aSpectator | self ball addDependent: aSpectator]! !

!Court methodsFor: 'printing'!

printOn: aStream
	"Display ball and spectator information."

	aStream nextPutAll: self ball printString , '. '; cr.
	self ball dependents do: [:aSpectator | aStream nextPutAll: aSpectator printString , ' '; cr]! !

!Court methodsFor: 'actions'!

accept

	"This stub method was generated by UIDefiner"

	^self!

go
	Transcript clear.
	self reset.
	1 to: numberOfMoves value
		do: 
			[:number | 
			Transcript cr; cr; show: 'Move number ' , number printString; cr; show: self printString.
			self ball move]! !

!Court methodsFor: 'aspects'!

courtLength
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^courtLength isNil
		ifTrue:
			[courtLength := 0 asValue]
		ifFalse:
			[courtLength]!

courtWidth
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^courtWidth isNil
		ifTrue:
			[courtWidth := 0 asValue]
		ifFalse:
			[courtWidth]!

numberOfMoves
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^numberOfMoves isNil
		ifTrue:
			[numberOfMoves := 0 asValue]
		ifFalse:
			[numberOfMoves]!

numberOfSpectators
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^numberOfSpectators isNil
		ifTrue:
			[numberOfSpectators := 0 asValue]
		ifFalse:
			[numberOfSpectators]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Court class
	instanceVariableNames: ''!


!Court class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'Tennis' 
			#min: #(#Point 412 121 ) 
			#max: #(#Point 412 121 ) 
			#bounds: #(#Rectangle 194 240 606 361 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#LabelSpec 
					#layout: #(#Point 15 29 ) 
					#label: 'Court length' ) 
				#(#LabelSpec 
					#layout: #(#Point 15 57 ) 
					#label: 'Court width' ) 
				#(#LabelSpec 
					#layout: #(#Point 300 14 ) 
					#label: 'Number of moves' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 146 31 249 50 ) 
					#model: #courtLength 
					#alignment: #center 
					#type: #number ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 146 59 249 78 ) 
					#model: #courtWidth 
					#alignment: #center 
					#type: #number ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 301 38 404 57 ) 
					#model: #numberOfMoves 
					#alignment: #center 
					#type: #number ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 325 76 377 101 ) 
					#model: #go 
					#label: 'Go' 
					#defaultable: true ) 
				#(#GroupBoxSpec 
					#layout: #(#Rectangle 8 12 255 110 ) 
					#label: 'Parameters' ) 
				#(#LabelSpec 
					#layout: #(#Point 15 85 ) 
					#label: 'Number of spectators' ) 
				#(#InputFieldSpec 
					#layout: #(#Rectangle 146 87 249 106 ) 
					#model: #numberOfSpectators 
					#alignment: #center 
					#type: #number ) ) ) )! !

Object subclass: #ShoppingMinder2
	instanceVariableNames: 'items selectedItems '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 8'!


!ShoppingMinder2 methodsFor: 'adding'!

addItem
	"Obtain an Item object from the user or an indication that no more items are needed. Add it to items."

	| name price |
	name := Dialog request: 'Enter item name' initialAnswer: ''.
	name isEmpty ifTrue: [^false].	"Exit and terminate loop - user indicated end of entry."
	price := (Dialog request: 'Enter item price' initialAnswer: '') asNumber.
	items add: (Item name: name price: price).
	^true! !

!ShoppingMinder2 methodsFor: 'displaying'!

displayExpensiveItems
	"Display a heading and all items that cost more than 10 dollars."

	Transcript cr; cr; show: 'Expensive items:'; cr.
	selectedItems do: [:item | item isExpensive ifTrue: [Transcript show: item displayString; cr]]!

displayItems
	"Display alphabetically all items selected by the customer along with their prices. Use alphabetical 
	order."

	Transcript clear.
	(selectedItems asSortedCollection: [:item1 :item2 | item1 name < item2 name])
		do: [:item | Transcript show: item displayString , '   number of units: ' , (selectedItems occurrencesOf: item) printString; cr]!

displayTotal
	"Add together prices of all selected items and display them in Transcript."

	Transcript cr; show: 'Total price: '; tab; show: (selectedItems inject: (Currency cents: 0)
			into: [:total :item | total + item price]) displayString! !

!ShoppingMinder2 methodsFor: 'selecting'!

selectItem
"Open window with available items and allow customer to make selections."

	| labels selectedItem |
	labels := items collect: [:anItem | anItem name].
	selectedItem := Dialog
				choose: 'Select an item and click OK. Click Cancel to stop.'
				fromList: labels
				values: items
				lines: 5
				cancel: [nil].
	selectedItem isNil
		ifTrue: [^false]
		ifFalse: 
			[selectedItems add: selectedItem.
			^true]! !

!ShoppingMinder2 methodsFor: 'execution'!

execute
	"Let store person add items, let the user select, and display the results."

	[self addItem] whileTrue.
	[self selectItem] whileTrue.
	self displayItems.
	self displayTotal.
	self displayExpensiveItems! !

!ShoppingMinder2 methodsFor: 'initialization'!

initialize
	"Initialize items to a suitably sized ordered collection."

	items := (SortedCollection new: 20)
				sortBlock: [:item1 :item2 | item1 name < item2 name].
	selectedItems := Bag new: 20! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ShoppingMinder2 class
	instanceVariableNames: ''!


!ShoppingMinder2 class methodsFor: 'creation'!

new
	^super new initialize! !

Object subclass: #Spectator
	instanceVariableNames: 'angle court location '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 8'!


!Spectator methodsFor: 'accessing'!

angle

	^angle!

angle: aValue

	angle := aValue!

court

	^court!

court: aValue

	court := aValue!

location

	^location!

location: aValue

	location := aValue! !

!Spectator methodsFor: 'creation'!

court: aCourt location: anInteger 
	self court: aCourt.
	self location: anInteger.
	self calculateAngle! !

!Spectator methodsFor: 'private'!

calculateAngle
	"Find angle for this spectator from current ball position."

	| ballPosition xDistance |
	ballPosition := self court ball position.
	xDistance := ballPosition - location.
	self angle: ((xDistance / court courtWidth value) arcTan)! !

!Spectator methodsFor: 'updating'!

update: aSymbol with: anInteger 
	self calculateAngle! !

!Spectator methodsFor: 'printing'!

printOn: aStream 
	aStream nextPutAll: 'Spectator location: ' , self location printString , ' angle: ' , (self angle asFixedPoint: 2) printString! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Spectator class
	instanceVariableNames: ''!


!Spectator class methodsFor: 'creating'!

court: aCourt location: anInteger 
	^self new court: aCourt location: anInteger! !

ApplicationModel subclass: #ListProperties
	instanceVariableNames: 'labels '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 8'!


!ListProperties methodsFor: 'actions'!

add
"Request a new label. If one is supplied, add it to the list holder."
| string |
	string := Dialog request: 'Enter new item' initialAnswer: ''.
	string isEmpty
ifFalse: 	[Transcript cr; show: 'added ' , string.
			labels list: ((labels listHolder value) add: string; yourself)]!

delete
"Check if there is a selection. If so, delete it from the list."
	labels selection isNil
		ifFalse:	[| newList |
			Transcript cr; show: 'deleted ' , labels selection.
			newList := (labels listHolder value) remove: labels selection; yourself.
			labels list: newList]!

print
"Display all labels in the Transcript."
	Transcript cr.
	labels listHolder value do: [:item | Transcript show: item; cr]! !

!ListProperties methodsFor: 'aspects'!

labels
	"This method was generated by UIDefiner.  Any edits made here
	may be lost whenever methods are automatically defined.  The
	initialization provided below may have been preempted by an
	initialize method."

	^labels isNil
		ifTrue:
			[labels := SelectionInList new]
		ifFalse:
			[labels]! !

!ListProperties methodsFor: 'change'!

printChange
"List selection has changed, print appropriate message to Transcript."
	labels selection isNil
		ifTrue: [Transcript cr; show: 'no selection']
		ifFalse: [Transcript cr; show: 'selection is ', labels selection]! !

!ListProperties methodsFor: 'initialization'!

initialize
"Initialize labels in list and register interest in change in list selection."
	labels := SelectionInList with: #('label 1' 'label 2' 'label 3') asOrderedCollection.
	labels selectionIndexHolder onChangeSend: #printChange to: self! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ListProperties class
	instanceVariableNames: ''!


!ListProperties class methodsFor: 'interface specs'!

windowSpec
	"UIPainter new openOnClass: self andSelector: #windowSpec"

	<resource: #canvas>
	^#(#FullSpec 
		#window: 
		#(#WindowSpec 
			#label: 'List Properties' 
			#bounds: #(#Rectangle 300 200 500 394 ) 
			#isEventDriven: true ) 
		#component: 
		#(#SpecCollection 
			#collection: #(
				#(#SequenceViewSpec 
					#layout: #(#Rectangle 12 7 189 149 ) 
					#model: #labels 
					#useModifierKeys: true 
					#selectionType: #highlight ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 9 161 61 186 ) 
					#model: #add 
					#label: 'Add' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 75 161 127 186 ) 
					#model: #delete 
					#label: 'Delete' 
					#defaultable: true ) 
				#(#ActionButtonSpec 
					#layout: #(#Rectangle 141 161 193 186 ) 
					#model: #print 
					#label: 'Print' 
					#defaultable: true ) ) ) )! !

Model subclass: #Ball
	instanceVariableNames: 'court direction position '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 8'!


!Ball methodsFor: 'accessing'!

court

	^court!

court: aValue

	court := aValue!

direction

	^direction!

direction: aValue

	direction := aValue!

position

	^position!

position: aValue

	position := aValue! !

!Ball methodsFor: 'private'!

reset
	self position: self court courtLength value.
	self direction: #left!

reverseDirection
	self direction: (self direction == #left
			ifTrue: [#right]
			ifFalse: [#left])! !

!Ball methodsFor: 'moving'!

move
	self direction == #left
		ifTrue: [self position: self position - 1]
		ifFalse: [self position: self position + 1].
	self changed: #position with: self position.
	self endOfTrack ifTrue: [self reverseDirection]! !

!Ball methodsFor: 'testing'!

endOfTrack
	^position = 1 or: [position = self court courtLength value]! !

!Ball methodsFor: 'printing'!

printOn: aStream 
	aStream nextPutAll: 'Ball position: ' , self position printString , ' direction: ' , self direction asString! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Ball class
	instanceVariableNames: ''!


!Ball class methodsFor: 'instance creation'!

onCourt: aCourt 
	"Create a ball at the right end of the court."

	^(self new) court: aCourt; reset! !

Object subclass: #ShoppingMinder1
	instanceVariableNames: 'items '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Chapter 8'!


!ShoppingMinder1 methodsFor: 'displaying'!

displayExpensiveItems
	"Display a heading and all items that cost more than 10 dollars."

	Transcript cr; cr; show: 'Expensive items:'; cr.
	items do: [:item | item isExpensive ifTrue: [Transcript show: item displayString; cr]]!

displayItems
	"Display alphabetically all items selected by the customer along with their prices. Use alphabetical 
	order."

	Transcript clear.
	(items asSet asSortedCollection: [:item1 :item2 | item1 name < item2 name])
		do: [:item | Transcript show: item displayString; cr]!

displayTotal
	"Add together prices of all selected items and display them in Transcript."

	Transcript cr; show: 'Total price: '; tab; show: (items inject: (Currency cents: 0)
			into: [:total :item | total + item price]) displayString! !

!ShoppingMinder1 methodsFor: 'execution'!

execute
	"Get items from the user and display the results."

	[self addItem] whileTrue.
	self displayItems.
	self displayTotal.
	self displayExpensiveItems! !

!ShoppingMinder1 methodsFor: 'initialization'!

initialize
	"Initialize items to a suitably sized ordered collection."

	items := OrderedCollection new: 20! !

!ShoppingMinder1 methodsFor: 'private'!

addItem
	"Obtain an Item object from the user or an indication that no more items are needed. Add it to items."

	| name price |
	name := Dialog request: 'Enter item name' initialAnswer: ''.
	name isEmpty ifTrue: [^false].	"Exit and terminate loop - user indicated end of entry."
	price := Dialog request: 'Enter item price' initialAnswer: ''.
	price isEmpty ifTrue: [^false].	"Exit and terminate loop - user indicated end of entry."
	items add: (Item name: name price: price asNumber).
	^true! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ShoppingMinder1 class
	instanceVariableNames: ''!


!ShoppingMinder1 class methodsFor: 'creation'!

new
	^super new initialize! !

